"See below for the file-in stuff"

"A first parser test"
Test := SelfParser on: (ReadStream on:
'[ | slot1. slot2 | ''here is some code in a block'' printLine ]').
Test  halt; expression.
Test := nil

SelfObject initialize
SelfObject lobby

"A second parser test"
| parser |
(#( '()'
    '( | slot1. slot2 | ''here is some code'' printLine )'
    '[ | slot1. slot2 | ''here is some code in a block'' printLine ]'
    '( | x = 17. y = 18 | )'
    '1 to: 5 * i By: 2 * j Do: [ :k | k print ]' 
    '(| assertPositive: x = (
        x > 0 ifTrue: [ ^''ok'' ].
        error: ''non-positive x'' ) | )' 
    '( |    parent* = traits block. x = 3 + 4.  y = 5.  | )'
    '( |    parent* = traits block. x <- 3 + 4. y <- 5. | )'      
    '(| + = ( | :arg | (clone x: x + arg x) y: y + arg y ). | )'  
    '(| +arg = ((clone x: x + arg x) y: y + arg y) |)' 
    '(| ifTrue:False: = (|:trueBlock.:falseBlock|trueBlock value )|)'
    '(| ifTrue:trueBlock False:falseBlock = (trueBlock value) |)'
    '{''this object has one slot'' (| snort = 17 |)}'  
    '(| { ''Category: accessing''
            getOne = ().
            getAnother = ()
        }
            unannotatedSlot
    |)'          
    '17 print'  '5 factorial'   '5 factorial print'
    '3 + 4' '7 <-> 8'   '3 + 4 + 7' '3 + 4 * 7'
    '3 factorial + pi sine'
    '5 min: 4 Max: 7'   '5 min: 4 max: 7'
    '5 min: 6 min:7 Max: 8 Max: 9 min: 10 Max: 11'
    'factorial' '+ 3'   'max: 5'
    'resend.display'    'resend.+ 5'    'resend.min: 17 Max: 23'
    'listParent.height' 'intParent.min:17 Max: 23'
) collect: [ :each |
    parser := SelfParser on: (ReadStream on: each).
    parser expression
]) inspect

"The UI"
SelfWindow open
SelfObject lobby name

"START HERE...."
SelfObject initialize.

(SelfParser on: '''.\\objects\\core\\init.self'' _RunScript' readStream) expression evalIn: SelfObject lobby.

(SelfParser on: '''.\\objects\\core\\systemStructure.self'' _RunScript' readStream) expression evalIn: SelfObject lobby.

(SelfParser on: '''.\\objects\\core\\coreObjects.self'' _RunScript' readStream) expression evalIn: SelfObject lobby.


(SelfParser on: 'message copy receiver: nil Selector: ''HALLO'' Type: ''normal'' Delegatee: nil MethodHolder: nil Arguments: vector' readStream) expression halt evalIn: SelfObject lobby.

TODO
====

Get rid of StObject, unify Smalltalk and SELF objects
Add real support for vectors (_Close:Filler:, _At:, _At:Put:)
Implement failure blocks for integer primitives
_CloneBytes: is implemented incorrectly
_ThisProcess is a stub
Implement canonical strings, then correct _Eq:
Parser can't read "^-1" or "e-23"
Make read-in of core/snapshotAction possible (currently commented out)
Implement mirror parents, currently they're faked (this stops core/hosts.self)
Implement _OnNonLocalReturn:
Remove #, HACK in SelfSend>evalIn: which was added for fakeSlot.self